<?php
/**
 * Created by PhpStorm.
 * User: gets
 * Date: 4/4/2019
 * Time: 3:24 PM
 */

namespace App\Http\Controllers;

use App\Classes\MResponse;
use App\Http\Request\Application\CreateRequest;
use App\Http\Request\Application\UpdateRequest;

class ApplicationController extends BaseController
{
    public function create(CreateRequest $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;
        
        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userId') . '/applications'; 

        try {
            $response = $this->masheryClient()->request('POST', $url, [
                'json' => [
                    'name' => 'WebApp',
                    'username' => $request->get('username')
                ]
            ]);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }

    public function update(UpdateRequest $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;
        
        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userId') . '/applications/' . $request->get('appId'); 

        try {
            $response = $this->masheryClient()->request('PUT', $url, [
                'json' => [
                    'name' => 'UpdateApp',
                    'description' => 'Update'
                ]
            ]);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }

    public function delete(DeleteRequest $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;
        
        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userId') . '/applications/' . $request->get('appId'); 

        try {
            $response = $this->masheryClient()->request('DEL', $url);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }

    public function getByUserID(GetByUserIdRequest $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;
        
        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userId') . '/applications'; 

        try {
            $response = $this->masheryClient()->request('GET', $url);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }

    public function getByAppId(GetByAppId $request)
    {
        $mResponse = new MResponse();
        $statusCode = 200;
        
        $url = 'https://api.mashery.com/v3/rest/members/' . $request->get('userId') . '/applications/' . $request->get('appId'); 

        try {
            $response = $this->masheryClient()->request('GET', $url);

            $resBody = json_decode($response->getBody()->getContents(), true);

            if ($response->getStatusCode() != 200) {
                $statusCode = $response->getStatusCode();
                $mResponse->message = $resBody;
            } else {
                $mResponse->success = true;
                $mResponse->message = 'success';
                $mResponse->data = $resBody;
            }
        } catch (\Exception $e) {
            $statusCode = 500;
            $mResponse->message = $e->getMessage();
        }

        return response()->json($mResponse, $statusCode);
    }
}
